/*
# BSD 2-Clause License
#
# Copyright (c) 2022, Quarkslab SAS
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include <basetsd.h>
#pragma once
typedef UINT32              TPM_CC;
#define TPM_CC_FIRST                          (TPM_CC)(0x0000011F)
#define TPM_CC_PP_FIRST                       (TPM_CC)(0x0000011F)
#define TPM_CC_NV_UndefineSpaceSpecial        (TPM_CC)(0x0000011F)
#define TPM_CC_EvictControl                   (TPM_CC)(0x00000120)
#define TPM_CC_HierarchyControl               (TPM_CC)(0x00000121)
#define TPM_CC_NV_UndefineSpace               (TPM_CC)(0x00000122)
#define TPM_CC_ChangeEPS                      (TPM_CC)(0x00000124)
#define TPM_CC_ChangePPS                      (TPM_CC)(0x00000125)
#define TPM_CC_Clear                          (TPM_CC)(0x00000126)
#define TPM_CC_ClearControl                   (TPM_CC)(0x00000127)
#define TPM_CC_ClockSet                       (TPM_CC)(0x00000128)
#define TPM_CC_HierarchyChangeAuth            (TPM_CC)(0x00000129)
#define TPM_CC_NV_DefineSpace                 (TPM_CC)(0x0000012A)
#define TPM_CC_PCR_Allocate                   (TPM_CC)(0x0000012B)
#define TPM_CC_PCR_SetAuthPolicy              (TPM_CC)(0x0000012C)
#define TPM_CC_PP_Commands                    (TPM_CC)(0x0000012D)
#define TPM_CC_SetPrimaryPolicy               (TPM_CC)(0x0000012E)
#define TPM_CC_FieldUpgradeStart              (TPM_CC)(0x0000012F)
#define TPM_CC_ClockRateAdjust                (TPM_CC)(0x00000130)
#define TPM_CC_CreatePrimary                  (TPM_CC)(0x00000131)
#define TPM_CC_NV_GlobalWriteLock             (TPM_CC)(0x00000132)
#define TPM_CC_PP_LAST                        (TPM_CC)(0x00000132)
#define TPM_CC_GetCommandAuditDigest          (TPM_CC)(0x00000133)
#define TPM_CC_NV_Increment                   (TPM_CC)(0x00000134)
#define TPM_CC_NV_SetBits                     (TPM_CC)(0x00000135)
#define TPM_CC_NV_Extend                      (TPM_CC)(0x00000136)
#define TPM_CC_NV_Write                       (TPM_CC)(0x00000137)
#define TPM_CC_NV_WriteLock                   (TPM_CC)(0x00000138)
#define TPM_CC_DictionaryAttackLockReset      (TPM_CC)(0x00000139)
#define TPM_CC_DictionaryAttackParameters     (TPM_CC)(0x0000013A)
#define TPM_CC_NV_ChangeAuth                  (TPM_CC)(0x0000013B)
#define TPM_CC_PCR_Event                      (TPM_CC)(0x0000013C)
#define TPM_CC_PCR_Reset                      (TPM_CC)(0x0000013D)
#define TPM_CC_SequenceComplete               (TPM_CC)(0x0000013E)
#define TPM_CC_SetAlgorithmSet                (TPM_CC)(0x0000013F)
#define TPM_CC_SetCommandCodeAuditStatus      (TPM_CC)(0x00000140)
#define TPM_CC_FieldUpgradeData               (TPM_CC)(0x00000141)
#define TPM_CC_IncrementalSelfTest            (TPM_CC)(0x00000142)
#define TPM_CC_SelfTest                       (TPM_CC)(0x00000143)
#define TPM_CC_Startup                        (TPM_CC)(0x00000144)
#define TPM_CC_Shutdown                       (TPM_CC)(0x00000145)
#define TPM_CC_StirRandom                     (TPM_CC)(0x00000146)
#define TPM_CC_ActivateCredential             (TPM_CC)(0x00000147)
#define TPM_CC_Certify                        (TPM_CC)(0x00000148)
#define TPM_CC_PolicyNV                       (TPM_CC)(0x00000149)
#define TPM_CC_CertifyCreation                (TPM_CC)(0x0000014A)
#define TPM_CC_Duplicate                      (TPM_CC)(0x0000014B)
#define TPM_CC_GetTime                        (TPM_CC)(0x0000014C)
#define TPM_CC_GetSessionAuditDigest          (TPM_CC)(0x0000014D)
#define TPM_CC_NV_Read                        (TPM_CC)(0x0000014E)
#define TPM_CC_NV_ReadLock                    (TPM_CC)(0x0000014F)
#define TPM_CC_ObjectChangeAuth               (TPM_CC)(0x00000150)
#define TPM_CC_PolicySecret                   (TPM_CC)(0x00000151)
#define TPM_CC_Rewrap                         (TPM_CC)(0x00000152)
#define TPM_CC_Create                         (TPM_CC)(0x00000153)
#define TPM_CC_ECDH_ZGen                      (TPM_CC)(0x00000154)
#define TPM_CC_HMAC                           (TPM_CC)(0x00000155)
#define TPM_CC_Import                         (TPM_CC)(0x00000156)
#define TPM_CC_Load                           (TPM_CC)(0x00000157)
#define TPM_CC_Quote                          (TPM_CC)(0x00000158)
#define TPM_CC_RSA_Decrypt                    (TPM_CC)(0x00000159)
#define TPM_CC_HMAC_Start                     (TPM_CC)(0x0000015B)
#define TPM_CC_SequenceUpdate                 (TPM_CC)(0x0000015C)
#define TPM_CC_Sign                           (TPM_CC)(0x0000015D)
#define TPM_CC_Unseal                         (TPM_CC)(0x0000015E)
#define TPM_CC_PolicySigned                   (TPM_CC)(0x00000160)
#define TPM_CC_ContextLoad                    (TPM_CC)(0x00000161)
#define TPM_CC_ContextSave                    (TPM_CC)(0x00000162)
#define TPM_CC_ECDH_KeyGen                    (TPM_CC)(0x00000163)
#define TPM_CC_EncryptDecrypt                 (TPM_CC)(0x00000164)
#define TPM_CC_FlushContext                   (TPM_CC)(0x00000165)
#define TPM_CC_LoadExternal                   (TPM_CC)(0x00000167)
#define TPM_CC_MakeCredential                 (TPM_CC)(0x00000168)
#define TPM_CC_NV_ReadPublic                  (TPM_CC)(0x00000169)
#define TPM_CC_PolicyAuthorize                (TPM_CC)(0x0000016A)
#define TPM_CC_PolicyAuthValue                (TPM_CC)(0x0000016B)
#define TPM_CC_PolicyCommandCode              (TPM_CC)(0x0000016C)
#define TPM_CC_PolicyCounterTimer             (TPM_CC)(0x0000016D)
#define TPM_CC_PolicyCpHash                   (TPM_CC)(0x0000016E)
#define TPM_CC_PolicyLocality                 (TPM_CC)(0x0000016F)
#define TPM_CC_PolicyNameHash                 (TPM_CC)(0x00000170)
#define TPM_CC_PolicyOR                       (TPM_CC)(0x00000171)
#define TPM_CC_PolicyTicket                   (TPM_CC)(0x00000172)
#define TPM_CC_ReadPublic                     (TPM_CC)(0x00000173)
#define TPM_CC_RSA_Encrypt                    (TPM_CC)(0x00000174)
#define TPM_CC_StartAuthSession               (TPM_CC)(0x00000176)
#define TPM_CC_VerifySignature                (TPM_CC)(0x00000177)
#define TPM_CC_ECC_Parameters                 (TPM_CC)(0x00000178)
#define TPM_CC_FirmwareRead                   (TPM_CC)(0x00000179)
#define TPM_CC_GetCapability                  (TPM_CC)(0x0000017A)
#define TPM_CC_GetRandom                      (TPM_CC)(0x0000017B)
#define TPM_CC_GetTestResult                  (TPM_CC)(0x0000017C)
#define TPM_CC_Hash                           (TPM_CC)(0x0000017D)
#define TPM_CC_PCR_Read                       (TPM_CC)(0x0000017E)
#define TPM_CC_PolicyPCR                      (TPM_CC)(0x0000017F)
#define TPM_CC_PolicyRestart                  (TPM_CC)(0x00000180)
#define TPM_CC_ReadClock                      (TPM_CC)(0x00000181)
#define TPM_CC_PCR_Extend                     (TPM_CC)(0x00000182)
#define TPM_CC_PCR_SetAuthValue               (TPM_CC)(0x00000183)
#define TPM_CC_NV_Certify                     (TPM_CC)(0x00000184)
#define TPM_CC_EventSequenceComplete          (TPM_CC)(0x00000185)
#define TPM_CC_HashSequenceStart              (TPM_CC)(0x00000186)
#define TPM_CC_PolicyPhysicalPresence         (TPM_CC)(0x00000187)
#define TPM_CC_PolicyDuplicationSelect        (TPM_CC)(0x00000188)
#define TPM_CC_PolicyGetDigest                (TPM_CC)(0x00000189)
#define TPM_CC_TestParms                      (TPM_CC)(0x0000018A)
#define TPM_CC_Commit                         (TPM_CC)(0x0000018B)
#define TPM_CC_PolicyPassword                 (TPM_CC)(0x0000018C)
#define TPM_CC_ZGen_2Phase                    (TPM_CC)(0x0000018D)
#define TPM_CC_EC_Ephemeral                   (TPM_CC)(0x0000018E)
#define TPM_CC_PolicyNvWritten                (TPM_CC)(0x0000018F)
#define TPM_CC_LAST                           (TPM_CC)(0x0000018F)



// Table 23  Definition of TPM_CAP Constants
typedef UINT32 TPM_CAP;
#define TPM_CAP_FIRST            0x00000000
#define TPM_CAP_ALGS             0x00000000
#define TPM_CAP_HANDLES          0x00000001
#define TPM_CAP_COMMANDS         0x00000002
#define TPM_CAP_PP_COMMANDS      0x00000003
#define TPM_CAP_AUDIT_COMMANDS   0x00000004
#define TPM_CAP_PCRS             0x00000005
#define TPM_CAP_TPM_PROPERTIES   0x00000006
#define TPM_CAP_PCR_PROPERTIES   0x00000007
#define TPM_CAP_ECC_CURVES       0x00000008
#define TPM_CAP_LAST             0x00000008
#define TPM_CAP_VENDOR_PROPERTY  0x00000100


// Table 24  Definition of TPM_PT Constants <  IN/OUT, S>
typedef UINT32 TPM_PT;
#define TPM_PT_NONE                                0x00000000
#define PT_GROUP                                   0x00000100
#define PT_FIXED                               (PT_GROUP * 1)
#define TPM_PT_FAMILY_INDICATOR      ((TPM_PT)(PT_FIXED + 0))
#define TPM_PT_LEVEL                 ((TPM_PT)(PT_FIXED + 1))
#define TPM_PT_REVISION              ((TPM_PT)(PT_FIXED + 2))
#define TPM_PT_DAY_OF_YEAR           ((TPM_PT)(PT_FIXED + 3))
#define TPM_PT_YEAR                  ((TPM_PT)(PT_FIXED + 4))
#define TPM_PT_MANUFACTURER          ((TPM_PT)(PT_FIXED + 5))
#define TPM_PT_VENDOR_STRING_1       ((TPM_PT)(PT_FIXED + 6))
#define TPM_PT_VENDOR_STRING_2       ((TPM_PT)(PT_FIXED + 7))
#define TPM_PT_VENDOR_STRING_3       ((TPM_PT)(PT_FIXED + 8))
#define TPM_PT_VENDOR_STRING_4       ((TPM_PT)(PT_FIXED + 9))
#define TPM_PT_VENDOR_TPM_TYPE      ((TPM_PT)(PT_FIXED + 10))
#define TPM_PT_FIRMWARE_VERSION_1   ((TPM_PT)(PT_FIXED + 11))
#define TPM_PT_FIRMWARE_VERSION_2   ((TPM_PT)(PT_FIXED + 12))
#define TPM_PT_INPUT_BUFFER         ((TPM_PT)(PT_FIXED + 13))
#define TPM_PT_HR_TRANSIENT_MIN     ((TPM_PT)(PT_FIXED + 14))
#define TPM_PT_HR_PERSISTENT_MIN    ((TPM_PT)(PT_FIXED + 15))
#define TPM_PT_HR_LOADED_MIN        ((TPM_PT)(PT_FIXED + 16))
#define TPM_PT_ACTIVE_SESSIONS_MAX  ((TPM_PT)(PT_FIXED + 17))
#define TPM_PT_PCR_COUNT            ((TPM_PT)(PT_FIXED + 18))
#define TPM_PT_PCR_SELECT_MIN       ((TPM_PT)(PT_FIXED + 19))
#define TPM_PT_CONTEXT_GAP_MAX      ((TPM_PT)(PT_FIXED + 20))
#define TPM_PT_NV_COUNTERS_MAX      ((TPM_PT)(PT_FIXED + 22))
#define TPM_PT_NV_INDEX_MAX         ((TPM_PT)(PT_FIXED + 23))
#define TPM_PT_MEMORY               ((TPM_PT)(PT_FIXED + 24))
#define TPM_PT_CLOCK_UPDATE         ((TPM_PT)(PT_FIXED + 25))
#define TPM_PT_CONTEXT_HASH         ((TPM_PT)(PT_FIXED + 26))
#define TPM_PT_CONTEXT_SYM          ((TPM_PT)(PT_FIXED + 27))
#define TPM_PT_CONTEXT_SYM_SIZE     ((TPM_PT)(PT_FIXED + 28))
#define TPM_PT_ORDERLY_COUNT        ((TPM_PT)(PT_FIXED + 29))
#define TPM_PT_MAX_COMMAND_SIZE     ((TPM_PT)(PT_FIXED + 30))
#define TPM_PT_MAX_RESPONSE_SIZE    ((TPM_PT)(PT_FIXED + 31))
#define TPM_PT_MAX_DIGEST           ((TPM_PT)(PT_FIXED + 32))
#define TPM_PT_MAX_OBJECT_CONTEXT   ((TPM_PT)(PT_FIXED + 33))
#define TPM_PT_MAX_SESSION_CONTEXT  ((TPM_PT)(PT_FIXED + 34))
#define TPM_PT_PS_FAMILY_INDICATOR  ((TPM_PT)(PT_FIXED + 35))
#define TPM_PT_PS_LEVEL             ((TPM_PT)(PT_FIXED + 36))
#define TPM_PT_PS_REVISION          ((TPM_PT)(PT_FIXED + 37))
#define TPM_PT_PS_DAY_OF_YEAR       ((TPM_PT)(PT_FIXED + 38))
#define TPM_PT_PS_YEAR              ((TPM_PT)(PT_FIXED + 39))
#define TPM_PT_SPLIT_MAX            ((TPM_PT)(PT_FIXED + 40))
#define TPM_PT_TOTAL_COMMANDS       ((TPM_PT)(PT_FIXED + 41))
#define TPM_PT_LIBRARY_COMMANDS     ((TPM_PT)(PT_FIXED + 42))
#define TPM_PT_VENDOR_COMMANDS      ((TPM_PT)(PT_FIXED + 43))
#define TPM_PT_NV_BUFFER_MAX        ((TPM_PT)(PT_FIXED + 44))
#define PT_VAR                                 (PT_GROUP * 2)
#define TPM_PT_PERMANENT               ((TPM_PT)(PT_VAR + 0))
#define TPM_PT_STARTUP_CLEAR           ((TPM_PT)(PT_VAR + 1))
#define TPM_PT_HR_NV_INDEX             ((TPM_PT)(PT_VAR + 2))
#define TPM_PT_HR_LOADED               ((TPM_PT)(PT_VAR + 3))
#define TPM_PT_HR_LOADED_AVAIL         ((TPM_PT)(PT_VAR + 4))
#define TPM_PT_HR_ACTIVE               ((TPM_PT)(PT_VAR + 5))
#define TPM_PT_HR_ACTIVE_AVAIL         ((TPM_PT)(PT_VAR + 6))
#define TPM_PT_HR_TRANSIENT_AVAIL      ((TPM_PT)(PT_VAR + 7))
#define TPM_PT_HR_PERSISTENT           ((TPM_PT)(PT_VAR + 8))
#define TPM_PT_HR_PERSISTENT_AVAIL     ((TPM_PT)(PT_VAR + 9))
#define TPM_PT_NV_COUNTERS            ((TPM_PT)(PT_VAR + 10))
#define TPM_PT_NV_COUNTERS_AVAIL      ((TPM_PT)(PT_VAR + 11))
#define TPM_PT_ALGORITHM_SET          ((TPM_PT)(PT_VAR + 12))
#define TPM_PT_LOADED_CURVES          ((TPM_PT)(PT_VAR + 13))
#define TPM_PT_LOCKOUT_COUNTER        ((TPM_PT)(PT_VAR + 14))
#define TPM_PT_MAX_AUTH_FAIL          ((TPM_PT)(PT_VAR + 15))
#define TPM_PT_LOCKOUT_INTERVAL       ((TPM_PT)(PT_VAR + 16))
#define TPM_PT_LOCKOUT_RECOVERY       ((TPM_PT)(PT_VAR + 17))
#define TPM_PT_NV_WRITE_RECOVERY      ((TPM_PT)(PT_VAR + 18))
#define TPM_PT_AUDIT_COUNTER_0        ((TPM_PT)(PT_VAR + 19))
#define TPM_PT_AUDIT_COUNTER_1        ((TPM_PT)(PT_VAR + 20))


#define TPM_RH_OWNER    0x40000001
#define TPM_RH_NULL	    0x40000007

#define TPM_ALG_XOR		0x0a
#define TPM_ALG_SHA256  0x0b


enum POC_NUMBER {
	POC_OOB_READ,
	POC_OOB_WRITE
};


#pragma pack(1)
typedef struct _AUTH_RESPONSE {
	UINT16 tag;
	UINT32 size;
	UINT32 responseCode;
	UINT32 sessionHandle;
	UINT16 nonceTPMSize;
	CHAR nonceTPM[];
} AUTH_RESPONSE;


typedef struct _BASE_TPM_COMMAND {
	UINT16 tag;
	UINT32 size;
	UINT32 command;
} BASE_TPM_COMMAND;


typedef struct _TPMA_SESSION {
	UINT8 continueSession : 1;
	UINT8 auditExclusive : 1;
	UINT8 auditReset : 1;
	UINT8 reserved3_4 : 2;
	UINT8 decrypt : 1;
	UINT8 encrypt : 1;
	UINT8 audit : 1;
} TPMA_SESSION;


typedef struct _TPMS_AUTH_COMMAND {
	UINT32 sessionHandle;
	UINT16 nonceSize;
	TPMA_SESSION sessionAttributes;
	UINT16 authValue;
} TPMS_AUTH_COMMAND;


typedef struct _CREATE_PRIMARY {
	BASE_TPM_COMMAND base;
	UINT32 handle;
	UINT32 authorizationSize;
	TPMS_AUTH_COMMAND authCommand;
	UINT16 paramSize;
	UINT8 params[];
} CREATE_PRIMARY;


typedef struct _SHORT_CREATE_PRIMARY {
	BASE_TPM_COMMAND base;
	UINT32 handle;
	UINT32 authorizationSize;
	TPMS_AUTH_COMMAND authCommand;
} SHORT_CREATE_PRIMARY;


typedef struct _CREATE_SESSION {
	BASE_TPM_COMMAND base;
	UINT32 tpmKey;
	UINT32 bind;
	UINT16 nonceCallerLength;
	UINT8  nonceCaller[0x20];
	UINT16 encryptedSaltLength;
	UINT8  sessionType;
	UINT16 symmetricAlgorithm;
	UINT16 symmetricKeyBits;
	UINT16 authHash;
} CREATE_SESSION;

typedef struct _TPM_PROP {
	BASE_TPM_COMMAND base;
	UINT32 capability;
	UINT32 property;
	UINT32 property_count;
} TPM_PROP;


typedef struct {
	TPM_PT  property;
	UINT32  value;
} TPMS_TAGGED_PROPERTY;

typedef struct {
	UINT32                count;
	TPMS_TAGGED_PROPERTY  tpmProperty[1];
} TPML_TAGGED_TPM_PROPERTY;


typedef union {
	TPML_TAGGED_TPM_PROPERTY  tpmProperties;
}TPMU_CAPABILITIES;


typedef struct {
	UINT32 capability;
	TPMU_CAPABILITIES data;
} TPMS_CAPABILITY_DATA;

typedef struct {
	BASE_TPM_COMMAND base;
	UINT8 moreData;
	TPMS_CAPABILITY_DATA capabilityData;
} TPM_PROP_RESPONSE;